Description

It would be very nice if we have a little button near PRE block, so user can copy the entire content to clipboard.

This can be very useful when there are in the block informations that user wants to use other place.

This should work on issues and wikis.

Related issues:

Related to Redmine - Feature #5953: Copy RSS/REST API keys to clipboard with ... New 2010-07-24

Related to Redmine - Patch #42625: Adjust padding of the copy-to-clipboard bu... Closed

Related to Redmine - Patch #42697: Restrict copy button scope to .wiki pre tags Closed

Related to Redmine - Feature #40784: Add feature to get raw Textile/Markdown ... New

Related to Redmine - Defect #42818: Unnecessary margin below icons on the boa... Closed

Associated revisions

Revision 23663 - 2025-04-17 08:52 - Go MAEDA

Add a button to copy `pre` code block content to the clipboard (#29214).

Patch by Mizuki ISHIKAWA (user:ishikawa999) and Katsuya HIDAKA (user:hidakatsuya).

Revision 23719 - 2025-04-27 10:09 - Go MAEDA

Adjust padding of the copy-to-clipboard button in `pre` tag (#29214, #42625).

Patch by Mizuki ISHIKAWA (user:ishikawa999).

Revision 23775 - 2025-05-15 07:59 - Go MAEDA

Restrict copy button scope to `.wiki` pre tags (#29214, #42697).

Patch by Mizuki ISHIKAWA (user:ishikawa999).

History

#1 - 2018-07-10 00:38 - Go MAEDA

- Related to Feature #5953: Copy RSS/REST API keys to clipboard with javascript added

#2 - 2020-03-24 08:12 - Mizuki ISHIKAWA

- File feature-29214-1.patch added

- File ScreenShot.png added

This patch adds a copy button next to the pre tag.
ScreenShot.png 

#3 - 2021-11-15 12:40 - Aleksandar Pavic

+1 for this to be core feature!

#4 - 2024-01-03 16:01 - Nicolas Houdelot

+1

that would be great if this could be included in the next major release (6.0), as a patch already exist
#5 - 2025-02-28 07:35 - Mizuki ISHIKAWA

- File patch_demo.gif added

- File screenshot 2025-02-28 15.12.34.png added

- File 0001-Add-copy-button-to-pre-elements.patch added

I have attached a patch modified to work with the latest version of Redmine.

This patch updates the structure of the 

 tag using JavaScript, transforming it into the following HTML structure:

<pre><code class="html">

<notextile>

<div class="pre-wrapper">

  <a title="Copy" class="copy-pre-content-link icon-only">(copy icon)</a>

  <pre><code>text</code></pre>

</div>

</notextile>

 With this change, clicking the "Copy" link will copy the contents of the pre tag to the clipboard.

 screenshot 2025-02-28 15.12.34.png 

#6 - 2025-03-03 08:13 - Mizuki ISHIKAWA

#note-5 html conversion is broken, so I'll write it again.

I have attached a patch modified to work with the latest version of Redmine.

This patch updates the structure of the pre tag using JavaScript, transforming it into the following HTML structure:

<div class="pre-wrapper">

  <a title="Copy" class="copy-pre-content-link icon-only">(copy icon)</a>

  <pre><code>text</code></pre>

</div>

 With this change, clicking the "Copy" link will copy the contents of the pre tag to the clipboard.

#7 - 2025-03-07 07:45 - Katsuya HIDAKA

- File copy_button_inside_codeblock_demo.gif added

- File copy_button_inside_codeblock_screenshot.png added

- File 0002-Place-the-copy-button-inside-the-code-block.patch added

- File 0003-Remove-the-unused-button_copied-definition.patch added

I have confirmed that the patch posted in #note-5 works on Chrome, Firefox, and Safari. I think it is very good, but I have a suggestion regarding the

position of the copy button.

How about placing the copy button inside the code block? This improves the patch in #note-5 in the following two ways:

A UI where the copy button is inside the code block is more common, as seen in GitHub and Jira, making it more intuitive to use.

It avoids the need to reduce the code block's area. In #note-5, additional right margin was added to accommodate the copy button.

 copy_button_inside_codeblock_screenshot.png See also copy_button_inside_codeblock_demo.gif

Additionally, it seems that the button_copied definition added to locales/en.yml in #note-5 is not being used.

I have attached two additional patches (0002, 0003) to address these improvements.

#8 - 2025-03-07 08:21 - Mizuki ISHIKAWA

Katsuya HIDAKA wrote in #note-7:

I have attached two additional patches (0002, 0003) to address these improvements.

 Thanks for the patch! Looks good.

#9 - 2025-03-18 13:22 - Go MAEDA

- Target version set to Candidate for next major release
#10 - 2025-04-15 08:15 - Mizuki ISHIKAWA

- File 0001-Add-copy-button-to-pre-elements.patch added

Since the navigator.clipboard API is only available in secure contexts such as HTTPS, we added a fallback to use execCommand('copy') when the

API is not available.

- https://developer.mozilla.org/ja/docs/Web/API/Clipboard

- https://developer.mozilla.org/en-US/docs/Mozilla/Add-ons/WebExtensions/Interact_with_the_clipboard

The existing link copy feature has also been updated to use the same implementation that falls back to execCommand('copy') when

navigator.clipboard is unavailable.

The previous patches (0001, 0002, 0003) conflict with the latest code, so we’ve included a new patch that combines the changes from 0001–0003

along with the fallback implementation.

#11 - 2025-04-15 12:13 - Go MAEDA

- Target version changed from Candidate for next major release to 6.1.0

Setting the target version to 6.1.0.

#12 - 2025-04-17 07:56 - Mizuki ISHIKAWA

- File 0002-Fix-system-test-not-to-fail.patch added

Fixed a system test that was failing.

#13 - 2025-04-17 08:59 - Go MAEDA

- Subject changed from Button to copy PRE block content to clipboard to Button to copy `pre` code block content to the clipboard

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch in r23663. Thank you for your contribution.

pre blocks in formatted text now have a copy button that lets you copy their contents to the clipboard, as shown in the screenshot below.  The icon

appears when you hover over a code block.

 copy_button_inside_codeblock_screenshot.png 

#14 - 2025-04-27 10:05 - Go MAEDA

- Related to Patch #42625: Adjust padding of the copy-to-clipboard button in pre tag added

#15 - 2025-05-15 04:03 - Go MAEDA

- Related to Patch #42697: Restrict copy button scope to .wiki pre tags added

#16 - 2025-06-01 09:19 - Go MAEDA

- Related to Feature #40784: Add feature to get raw Textile/Markdown text in notes and descriptions added

#17 - 2025-06-04 03:08 - Go MAEDA

- Related to Defect #42818: Unnecessary margin below icons on the board-style projects page added

Files

feature-29214-1.patch 3.83 KB 2020-03-24 Mizuki ISHIKAWA

ScreenShot.png 55.5 KB 2020-03-24 Mizuki ISHIKAWA

patch_demo.gif 422 KB 2025-02-28 Mizuki ISHIKAWA

screenshot 2025-02-28 15.12.34.png 66.3 KB 2025-02-28 Mizuki ISHIKAWA

0001-Add-copy-button-to-pre-elements.patch 9.19 KB 2025-02-28 Mizuki ISHIKAWA

copy_button_inside_codeblock_screenshot.png 39.2 KB 2025-03-07 Katsuya HIDAKA

copy_button_inside_codeblock_demo.gif 573 KB 2025-03-07 Katsuya HIDAKA

0003-Remove-the-unused-button_copied-definition.patch 674 Bytes 2025-03-07 Katsuya HIDAKA

0002-Place-the-copy-button-inside-the-code-block.patch 1.07 KB 2025-03-07 Katsuya HIDAKA

0001-Add-copy-button-to-pre-elements.patch 15.5 KB 2025-04-15 Mizuki ISHIKAWA
0002-Fix-system-test-not-to-fail.patch 5.94 KB 2025-04-17 Mizuki ISHIKAWA
